//先扩展一下javascript的Date类型,增加一个函数,用于返回我们想要的 yyyy-MM-dd HH:mm:ss 这种时间格式
Date.prototype.format = function (format) {
    var date = {
        "M+": this.getMonth() + 1,
        "d+": this.getDate(),
        "h+": this.getHours(),
        "m+": this.getMinutes(),
        "s+": this.getSeconds(),
        "q+": Math.floor((this.getMonth() + 3) / 3),
        "S+": this.getMilliseconds()
    };

    if (/(y+)/i.test(format)) {
        format = format.replace(RegExp.$1, (this.getFullYear() + '').substr(4 - RegExp.$1.length));
    }

    for (var k in date) {
        if (new RegExp("(" + k + ")").test(format)) {
            format = format.replace(RegExp.$1, RegExp.$1.length == 1 ? date[k] : ("00" + date[k]).substr(("" + date[k]).length));
        }
    }

    return format;
}

function formatTime(jsonTime) {
    var date = new Date(parseInt(jsonTime.replace("/Date(", "").replace(")/", ""), 10));
    return date.format("yyyy-MM-dd hh:mm:ss");
}

function applyTime(jsonTime) {
    var date = new Date(parseInt(jsonTime.replace("/Date(", "").replace(")/", ""), 10));
    if (date.getMinutes() == 0) {
        return date.format("M月d日h点");
    }
    else {
        return date.format("M月d日h点m分");
    }
}

function applyDate(jsonTime) {
    var date = new Date(parseInt(jsonTime.replace("/Date(", "").replace(")/", ""), 10));
    return date.format("M月d日");
}

function statusName(status) {
    if (status == 1) {
        return "待审批";
    }
    else if (status == 2) {
        return "审批通过";
    }
    return "驳回";
}

function openFrame(name, url, y) {
    //if (isIOS()) {
    //    var split = 3;
    //    if (window.screen.width < 414) {
    //        split = 2;
    //    }
    //    if (window.screen.width < 320) {
    //        split = 1;
    //    }
    //    var mb = 0;
    //    if (null != $$("footer") && undefined != $$("footer")) {
    //        mb = parseInt($$("footer").offsetHeight / split + 1); 
    //    }
    //    uexWindow.openPopover({
    //        name: name,
    //        url: url,
    //        x: 0,
    //        y: y / split,
    //        bottomMargin: mb
    //    });
    //}
    //else {
        appcan.frame.open(name, url, 0, y);
    //}
}

/********************************* 后台数据访问基本接口 *********************************/
var apiPerfix = "http://cloud.hysoon.com:80";
//var apiPerfix = "http://kq3.peface.com:7001";

var urlPrefix = apiPerfix + "/msV251";
var imgPrefix = apiPerfix;

function isIOS() {
    var os = getCache("_Cache_DeviceOS");
    if (os == "0") {
        return true;
    }
    return false;
}

function geturl(page, args) {
    if (args == undefined || args  == null) {
        return urlPrefix + page;
    }
    else {
        var query = "";
        for (var x in args) {
            if (query == "")
                query = "?" + x + "=" + args[x];
            else
                query = query + "&" + x + "=" + args[x];
        }
        return urlPrefix + page + query;
    }
}
/********************************* 后台数据访问基本接口 END *********************************/

/********************************* 工具函数及LocalStorage *********************************/
function set_touchevent(selector) {
    $(selector).on("touchstart", function () {
        $(this).addClass("sc-bg-active");
    }).on("touchend", function () {
        $(this).removeClass("sc-bg-active");
        }).on("touchcancel", function () {
            $(this).removeClass("sc-bg-active");
        }).on("click", function () {
            $(this).removeClass("sc-bg-active");
        });
}

function $$(id) {
    return document.getElementById(id);
}

function int(s) {
    return parseInt(s);
}

function float(s) {
    return parseFloat(s);
}

function tralert(content){
    appcan.window.alert("系统提醒", content);
}

function getCache(key) {
    var data = window.localStorage.getItem(key);
    if (data == null
        || data == undefined
        || data == "null"
        || data == "undefined") {
        data = "";
    }
    return data;
}

function setCache(key, data) {
    window.localStorage.setItem(key, data);
}

/********************************* 工具函数及LocalStorage END *********************************/

/********************************* 缓存数据读写及清理 *********************************/
//缓存数据到数据库中
function writeSqliteCache(key, value) {
    var db = openDatabase('appdb', '1.0', 'dataCache', 50 * 1024 * 1024);
    db.transaction(function (tx) {
        tx.executeSql('CREATE TABLE IF NOT EXISTS cacheTable (key text, value text, time INTEGER)');
        var now = int((new Date().getTime()) / 1000);
        tx.executeSql("Delete FROM cacheTable where key='" + key + "'");
        tx.executeSql("INSERT INTO cacheTable (key, value, time) VALUES('" + key + "','" + value + "', " + now + ")");
    });
}

//缓存数据到数据库中
function readSqliteCache(key, callback) {
    var db = openDatabase('appdb', '1.0', 'dataCache', 20 * 1024 * 1024);
    db.transaction(function (tx) {
        tx.executeSql('CREATE TABLE IF NOT EXISTS cacheTable (key text, value text, time INTEGER)');
        var sql = "Select key,value,time FROM cacheTable where key='" + key + "'";
        tx.executeSql(sql, [], function (tx, results) {
            var len = results.rows.length;
            if (len == 0) {
                callback(false, "", 0);
            }
            callback(true, results.rows.item(0).value, results.rows.item(0).time);
        }, null);
    });
}

// 清理数据库缓存
function clearDBCache() {
    var db = openDatabase('appdb', '1.0', 'dataCache', 50 * 1024 * 1024);
    db.transaction(function (tx) {
        tx.executeSql('DROP TABLE cacheTable');
    });
}
/********************************* 缓存数据读写及清理 *********************************/

/********************************* 后台数据访问 *********************************/
function appCanGet(page, args, callback, useCache, cacheTime, onErr) {
    uexWindow.toast(1, 5, "加载中...", 0);
    args["globalid"] = getCache("Cache_Logon_GlobalId");
    args["enpwd"] = getCache("Cache_Logon_Pwd");
    args["imei"] = getCache("_Cache_DeviceIMEI");
    var url = geturl(page, args);
    if (!useCache) {
        appcanAjax(url, callback, useCache, onErr);
        return;
    }
    var key = hex_md5(url);
    readSqliteCache(key, function (hasData, data, time) {
        var now = int((new Date().getTime()) / 1000);
        if (hasData && (undefined == cacheTime || cacheTime == 0 || (now - time) <= cacheTime * 3600)){
            callback(data);
            uexWindow.closeToast();
            return;
        }
        else {
            appcanAjax(url, callback, useCache, onErr);
            return;
        }
    });
}
function appcanAjax(url, callback, useCache, onErr) {
    appcan.request.ajax({
        type: 'get',
        url: encodeURI(url),
        //期望的返回类型
        dataType: 'text',
        success: function (result) {
            $(".netErr").remove();
            if (useCache && result != "") {
                var key = hex_md5(url);
                writeSqliteCache(key, result);
            }
            callback(result);
            uexWindow.closeToast();
        },
        error: function (xhr, type) {
            if (onErr == undefined) {
                uexWindow.closeToast();
            }
            else {
                uexWindow.closeToast();
                onErr();
            }
        }
    });
}

function appcanPost(page, data, callback) {
    var url = geturl(page);

    var args = {};
    $.each(data, function (i, v) {
        args[v.name] = v.value;
    });
    args["globalid"] = getCache("Cache_Logon_GlobalId");
    args["enpwd"] = getCache("Cache_Logon_Pwd");
    args["imei"] = getCache("_Cache_DeviceIMEI");

    appcan.request.post(url, args, function (result, status, xhr) {
        callback(result);
    }, 'text');
}
/********************************* 后台数据访问 END *********************************/

/********************************* 网络错误及数据为空显示 *********************************/
function showNetError(callback) {
    var element = document.createElement("div");
    element.className = "netErr";
    document.body.appendChild(element);
    $(".netErr").click(function () {
        $(".netErr").remove()
        if (callback != undefined) {
            callback();
        }
    });
}

function showEmpty(callback) {
    var element = document.createElement("div");
    element.className = "contentEmpty";
    document.body.appendChild(element);
    $(".contentEmpty").click(function () {
        $(".contentEmpty").remove()
        if (callback != undefined) {
            callback();
        }
    });
}
/********************************* 网络错误及数据为空显示 END *********************************/

/********************************* 登录用户信息 *********************************/
function go_logon(module, pagename) {
    setCache("Cache_Logon_FromModule", module);
    setCache("Cache_Logon_FromPage", pagename);

    openwin("user", "logon");
}

/********************************* 登录用户信息 END *********************************/


/********************************* 打开新页面公共函数 *********************************/
function openwin(module, pagename) {
    uexWindow.open({
        name: module + "." + pagename,
        dataType: 0,
        data: "../app_" + module + "/" + pagename + ".html",
        animID: 2,
        flag: 4
    });

}

function openttt(module, pagename, title) {
    setCache("Cache_TTT_Title", title);
    var contentPage = "../app_" + module + "/" + pagename + ".html";
    setCache("Cache_TTT_ContentPage", contentPage);

    uexWindow.open({
        name: module + "." + pagename,
        dataType: 0,
        data: "../ttt/index.html",
        animID: 2,
        flag: 4
    });
}

function openttt_apply(module, pagename, title) {
    setCache("Cache_TTT_Title", title);
    var contentPage = "../app_" + module + "/" + pagename + ".html";
    setCache("Cache_TTT_ContentPage", contentPage);

    uexWindow.open({
        name: module + "." + pagename,
        dataType: 0,
        data: "../ttt/apply.html",
        animID: 2,
        flag: 4
    });
}

function open_applylist(pagename, title) {
    setCache("Cache_TTT_Title", title);
    var contentPage = "../app_apply/index_" + pagename + ".html";
    setCache("Cache_TTT_ApplyAdd", pagename);
    setCache("Cache_TTT_ContentPage", contentPage);

    uexWindow.open({
        name: "apply." + pagename,
        dataType: 0,
        data: "../ttt/applylist.html",
        animID: 2,
        flag: 4
    });
}

function openttt_apply_mgr(module, pagename, title) {
    setCache("Cache_TTT_Title", title);
    var contentPage = "../app_" + module + "/" + pagename + ".html";
    setCache("Cache_TTT_ContentPage", contentPage);

    uexWindow.open({
        name: module + "." + pagename,
        dataType: 0,
        data: "../ttt/apply_mgr.html",
        animID: 2,
        flag: 4
    });
}

/********************************* 打开新页面公共函数 END *********************************/

/********************************* 验证数据合法性 *********************************/
function isMobile(s) {
    var regu = /^[1][3|4|5|6|7|8|9][0-9]{9}$/;
    var re = new RegExp(regu);
    if (re.test(s)) {
        return true;
    } else {
        return false;
    }
}
/********************************* 验证数据合法性 END *********************************/

function pageBounce(downcb, upcb) {
    uexWindow.onBounceStateChange = function (t, s) {
        //t: 对应的部位值，int型数据，0为网页顶端，1为网页底部。
        //s：当type=0时，值0为向下拉，1为超越边界，2为向上返回到最初状态；当type=1时，0为向上拉，1为超越边界，2为向下返回到最初状态。
        if (t == 0 && s == 2) {   // 页面顶部，向下拉
            if (downcb != undefined) {
                downcb();
            }
            appcan.window.resetBounceView(0);
        }
        if (t == 1 && s == 2) {   // 页面底部，向上拉
            if (upcb != undefined) {
                upcb();
            }
            appcan.window.resetBounceView(1);

        }
    };

    uexWindow.setBounce(1);//指定当前网页弹动效果
    uexWindow.showBounceView(0, "#eee", 1); //支持网页顶部弹动
    uexWindow.showBounceView(1, "#eee", 1); //支持网页底部弹动
    uexWindow.notifyBounceEvent(0, 1);  // 注册顶部接收弹动事件。
    uexWindow.notifyBounceEvent(1, 1); // 注册底部接收弹动事件。
    //uexWindow.setBounceParams(0, '{"loadingText":"重新加载","pullToReloadText":"下拉刷新"}'); // 顶部弹动显示内容
    //uexWindow.setBounceParams(1, '{"loadingText":"加载更多","pullToReloadText":"加载更多"}');// 底部弹动显示内容
    appcan.window.setBounceParams({
        position: 0,
        data: {
            "imagePath": "",
            "textColor": "#530606",
            "pullToReloadText": "重新加载",
            "releaseToReloadText": "释放刷新",
            "loadingText": "加载中，请稍等"
        }
    });
    appcan.window.setBounceParams({
        position: 1,
        data: {
            "imagePath": "",
            "textColor": "#530606",
            "pullToReloadText": "加载更多",
            "releaseToReloadText": "释放刷新",
            "loadingText": "加载中，请稍等"
        }
    });
}


function get_location() {
    if (getCache("Cache_Location_Lat") == ""
        || getCache("Cache_Location_Long") == ""
        || getCache("Cache_Location_Lat") == "0"
        || getCache("Cache_Location_Long") == "0") {
        setCache("Cache_Location_Lat", 37.511);
        setCache("Cache_Location_Long", 122.114);
    }
    uexLocation.onChange = function (lat, log) {//获得用户经纬度
        setCache("Cache_Location_Lat", lat);//纬度
        setCache("Cache_Location_Long", log);//经度
    };
    uexLocation.openLocation();//打开定位 
}

function getHeadImg(headimg) {
    if (headimg == "" || headimg == undefined || headimg == null) {
        headimg = "../css/images/default_head.png";
    }
    else {
        headimg = imgPrefix + headimg;
    }
    return headimg;
}

// 数字转为两位
function ToTimeFix(intValue) {
    var setValue = "0" + intValue;
    setValue = setValue.substr(setValue.length - 2, 2);
    return setValue;
}

// 下拉菜单
function selectChange(obj) {
    var selectText = $(obj).find("option:selected").text();
    $(obj).parent().find("div.text").text(selectText);
}

// 日期选择
function setDate(obj, hideCtrl) {
    var dateString = $(obj).find("span").text();
    var date = new Date(Date.parse(dateString));
    uexControl.openDatePicker(date.getFullYear(), date.getMonth() + 1, date.getDate(), function (data) {
        var setString = data.year + "-" + ToTimeFix(data.month) + "-" + ToTimeFix(data.day);
        $(obj).find("span").text(setString);
        $$(hideCtrl).value = setString;
    });
}

// 时间选择
function setTime(obj, hideCtrl) {
    var timeString = $(obj).find("span").text();
    var timeArr = timeString.split(":");
    var hour = parseInt(timeArr[0]);
    var minute = parseInt(timeArr[1]);

    uexControl.openTimePicker(hour, minute, function (data) {
        var timeString2 = ToTimeFix(data.hour) + ":" + ToTimeFix(data.minute);

        $(obj).find("span").text(timeString2);
        $$(hideCtrl).value = timeString2;
    });
}


// 缓存说明：用于getCache，setCache调用
// _Cache_FontSize              字体大小
// _Cache_DeviceOS              操作系统OS
// _Cache_DeviceIMEI            设备IMEI序列号
// Cache_Logon_GlobalId:        登录用户全局ID
// Cache_Logon_CompanyID:       登录用户企业ID
// Cache_CompanyEnableContact   是否启用通讯录
// Cache_Logon_UserID           登录用户考勤序号
// Cache_Logon_Pwd              登陆密码
// Cache_Logon_IsMgr            登陆密码
// Cache_Logon_NeedKaoQin       是否需要考勤
// Cache_Logon_HasPay           付费用户
// Cache_Logon_CompName         登录公司名称
// Cache_Location_Long          位置_经度
// Cache_Location_Lat           位置_纬度
// Cache_Logon_FromModule       登录返回模块，默认值home
// Cache_Logon_FromPage         登录返回页面，默认值index
// Cache_TTT_Title              ttt页面title
// Cache_TTT_ContentPage        ttt页面的content内容分页


